package com.bipt.intelligentapplicationorchestrationservice.mapper;

import com.bipt.intelligentapplicationorchestrationservice.entity.ModelSelectVO;
import com.bipt.intelligentapplicationorchestrationservice.pojo.ServicePublishDTO;
import com.bipt.intelligentapplicationorchestrationservice.pojo.ServicePublishVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.util.List;

@Mapper
public interface PublishMapper {



    void insert(ServicePublishDTO servicePublishDTO);

    Long getByApiUrl(String apiUrl);

    @Select("SELECT model_id,api_url,ip FROM service_publish")
    List<ServicePublishVO> listPublishedServices();
    @Select("SELECT " +
            "mv.model_id AS modelId, " +
            "m.model_name AS modelName, " +
            "mv.version AS version " +
            "FROM model_version mv " +
            "LEFT JOIN model_info m ON mv.model_id = m.id")
    List<ModelSelectVO> selectModelSelectList();
}
