package com.bipt.intelligentapplicationorchestrationservice.pojo;

import com.fasterxml.jackson.annotation.JsonProperty;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Pattern;
import lombok.*;

@Data
@NoArgsConstructor
@AllArgsConstructor
@Setter
@Getter
public class GpuCreateDTO {
    @NotBlank(message = "GPU型号不能为空")
    @Pattern(regexp = "^([A-Z][A-Z0-9-]+)-\\w+",
            message = "型号格式应为 [厂商（大写字母开头）]-[型号]，如 Intel-Xe_GPU")
    @JsonProperty("GPUModel") // 显示指定JSON映射名称
    private String GPUModel;

    @NotNull(message = "显存容量不能为空")
    @JsonProperty("GPUMemorySize")
    private Integer GPUMemorySize;

    @NotBlank(message = "IP地址不能为空")
    @Pattern(regexp = "^(\\d{1,3}\\.){3}\\d{1,3}$",
            message = "IP地址格式无效")
    @JsonProperty("Ip") // 显示指定JSON映射名称
    private String Ip;

}
