package com.bipt.intelligentapplicationorchestrationservice.pojo;

import com.fasterxml.jackson.annotation.JsonProperty;
import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Pattern;
import lombok.*;

@Data
@AllArgsConstructor
@NoArgsConstructor
@Setter
@Getter
public class GpuUpdateDTO {

    private Long GPUId;

    public @Pattern(regexp = "^([A-Z][A-Z0-9-]+)-\\w+",
            message = "型号格式应为 [厂商（大写字母开头）]-[型号]，如 Intel-Xe_GPU") String getGPUModel() {
        return GPUModel;
    }

    public @Pattern(regexp = "^\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}$",
            message = "IP地址格式无效") String getIp() {
        return Ip;
    }

    @Pattern(regexp = "^([A-Z][A-Z0-9-]+)-\\w+",
            message = "型号格式应为 [厂商（大写字母开头）]-[型号]，如 Intel-Xe_GPU")
    @JsonProperty("GPUModel") // 显示指定JSON映射名称
    private String GPUModel;

    @JsonProperty("GPUMemorySize") // 显示指定JSON映射名称
    private Integer GPUMemorySize;

    @Pattern(regexp = "^\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}$",
            message = "IP地址格式无效")
    @JsonProperty("Ip") // 显示指定JSON映射名称
    private String Ip;

    public void setGPUId(Long GPUId) {
        this.GPUId = GPUId;
    }

    public void setGPUModel(@Pattern(regexp = "^([A-Z][A-Z0-9-]+)-\\w+",
            message = "型号格式应为 [厂商（大写字母开头）]-[型号]，如 Intel-Xe_GPU") String GPUModel) {
        this.GPUModel = GPUModel;
    }

    public void setIp(@Pattern(regexp = "^\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}$",
            message = "IP地址格式无效") String ip) {
        Ip = ip;
    }
    public Long getGPUId() {
        return GPUId;
    }

    public Integer getGPUMemorySize() {
        return GPUMemorySize;
    }

    public void setGPUMemorySize(Integer GPUMemorySize) {
        this.GPUMemorySize = GPUMemorySize;
    }
}
